#--------------------------------------------------------------------------------
# 참조 모듈 목록.
#--------------------------------------------------------------------------------
from __future__ import annotations
from typing import Awaitable, Callable, Final, Generic, Iterable, Iterator, Optional, Sequence, Type, TypeVar, Tuple, Union
from typing import ItemsView, KeysView, ValuesView
from typing import Any, List, Dict, Set
from typing import cast, overload
import builtins
from xpl import Builtins


#--------------------------------------------------------------------------------
# 버전 데이터.
#--------------------------------------------------------------------------------
class VersionData():
	#--------------------------------------------------------------------------------
	# 멤버 변수 목록.
	#--------------------------------------------------------------------------------
	__major: int
	__minor: int
	__patch: int


	#--------------------------------------------------------------------------------
	# 메이저 버전.
	#--------------------------------------------------------------------------------
	@property
	def Major(self) -> int:
		return self.__major


	#--------------------------------------------------------------------------------
	# 메이저 버전.
	#--------------------------------------------------------------------------------
	@Major.setter
	def Major(self, value: int) -> None:
		self.__major = value
	

	#--------------------------------------------------------------------------------
	# 마이너 버전.
	#--------------------------------------------------------------------------------
	@property
	def Minor(self) -> int:
		return self.__minor


	#--------------------------------------------------------------------------------
	# 마이너 버전.
	#--------------------------------------------------------------------------------
	@Minor.setter
	def Minor(self, value: int) -> None:
		self.__minor = value

	
	#--------------------------------------------------------------------------------
	# 패치 버전.
	#--------------------------------------------------------------------------------
	@property
	def Patch(self) -> int:
		return self.__patch


	#--------------------------------------------------------------------------------
	# 패치 버전.
	#--------------------------------------------------------------------------------
	@Patch.setter
	def Patch(self, value: int) -> None:
		self.__patch = value


	#--------------------------------------------------------------------------------
	# 생성됨.
	#--------------------------------------------------------------------------------
	def __init__(self, major: int = 0, minor: int = 0, patch: int = 0) -> None:
		self.__major: int = major
		self.__minor: int = minor
		self.__patch: int = patch


	#--------------------------------------------------------------------------------
	# 버전 설정.
	#--------------------------------------------------------------------------------
	def SetVersion(self, version: str) -> None:
		separator: str = "."
		values = version.split(separator)
		self.Major = int(values[0])
		self.Minor = int(values[1])
		self.Patch = int(values[2])


	#--------------------------------------------------------------------------------
	# 버전 설정.
	#--------------------------------------------------------------------------------
	def SetVersion(self, major: int, minor: int, patch: int) -> None:
		self.Major = major
		self.Minor = minor
		self.Patch = patch


	#--------------------------------------------------------------------------------
	# 버전 설정.
	#--------------------------------------------------------------------------------
	def GetVersion(self) -> str:
		return f"{self.__major}.{self.__minor}.{self.__patch}"


	#--------------------------------------------------------------------------------
	# 문자열 반환.
	#--------------------------------------------------------------------------------
	def __str__(self) -> str:
		return self.GetVersion()